var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { saveAs } from "file-saver";
import * as ExcelJS from "exceljs";
export function exportToExcel(excelData, fileName, imageColumn) {
    return __awaiter(this, void 0, void 0, function* () {
        // Check if there is data to export
        if (excelData.length > 0) {
            // Create a new workbook and worksheet
            const workbook = new ExcelJS.Workbook();
            const worksheet = workbook.addWorksheet("data");
            // Get the headers of the data
            const headers = Object.keys(excelData[0] ? excelData[0] : { id: 1 });
            // Add headers to the worksheet
            worksheet.addRow(headers);
            // Iterate over each item in the data
            for (const item of excelData) {
                const row = [];
                // Iterate over each header
                headers.forEach((header) => {
                    // Add an empty string for the image column
                    if (header === imageColumn)
                        row.push("");
                    // Add the value of the current header
                    row.push(item[header]);
                });
                // Add the row to the worksheet
                worksheet.addRow(row);
            }
            // Set the width of each column to 25
            // Set the width of each column and enable text wrap
            headers.forEach((header, index) => {
                const column = worksheet.getColumn(index + 1);
                column.width = 25;
                column.alignment = { wrapText: true };
            });
            // Set the height of each row to 100
            worksheet.eachRow((row) => {
                row.height = 100;
            });
            // Write the workbook to a buffer
            const buffer = yield workbook.xlsx.writeBuffer();
            // Create a blob with the buffer and file type
            const blob = new Blob([buffer], { type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" });
            // Save the blob as a file
            saveAs(blob, fileName);
        }
    });
}
