/**
 * Determines if two ranges overlap.
 *
 * @param {T} start1 - The start value of the first range.
 * @param {T} end1 - The end value of the first range.
 * @param {T} start2 - The start value of the second range.
 * @param {T} end2 - The end value of the second range.
 * @return {boolean} True if the ranges overlap, false otherwise.
 */
export function Overlap(start1, end1, start2, end2) {
    if (start1 > end1 || start2 > end2) {
        console.error(`When Using Guard.Catch.Overlap from frontend-utility-functions, 
        start1 must be less than end1 and start2 must be less than end2. 
        This function call will always evaluate to false, as one of the ranges you provided is invalid. 
        your provided ranges are ${start1}-${end1} and ${start2}-${end2}`);
        return true;
    }
    //This Function should return True if the start and end values overlap
    return start1 <= end2 && start2 <= end1;
}
